.\" Copyright (c) 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)madvise.2	8.1 (Berkeley) 6/9/93
.\" $FreeBSD: src/lib/libc/sys/madvise.2,v 1.7.2.3 1999/09/05 11:16:47 peter Exp $
.\"
.Dd Jul 19, 1996
.Dt MADVISE 2
.Os
.Sh NAME
.Nm madvise
.Nd give advice about use of memory
.Sh SYNOPSIS
.Fd #include <sys/types.h>
.Fd #include <sys/mman.h>
.Ft int
.Fn madvise "caddr_t addr" "size_t len" "int behav"
.Sh DESCRIPTION
The
.Fn madvise
system call
allows a process that has knowledge of its memory behavior
to describe it to the system.
The known behaviors are given in
.Aq Pa sys/mman.h :
.Bd -literal
#define	MADV_NORMAL	0 /* no further special treatment */
#define	MADV_RANDOM	1 /* expect random page references */
#define	MADV_SEQUENTIAL	2 /* expect sequential references */
#define	MADV_WILLNEED	3 /* will need these pages */
#define	MADV_DONTNEED	4 /* don't need these pages */
#define	MADV_FREE	5 /* data is now unimportant */
.Ed
.Pp
.Bl -tag -width MADV_SEQUENTIAL 
.It Dv MADV_NORMAL
Tells the system to revert to the default paging
behavior.
.It Dv MADV_RANDOM
Is a hint that pages will be accessed randomly, and prefetching
is likely not advantageous.
.It Dv MADV_SEQUENTIAL
Causes the VM system to depress the priority of
pages immediately preceeding a given page when it is faulted in.
.It Dv MADV_WILLNEED
Causes pages that are in a given virtual address range
to temporarily have higher priority, and if they are in
memory, decrease the likelihood of them being freed.  Additionally,
the pages that are already in memory will be immediately mapped into
the process, thereby eliminating unnecessary overhead of going through
the entire process of faulting the pages in.  This WILL NOT fault
pages in from backing store, but quickly map the pages already in memory
into the calling process.
.It Dv MADV_DONTNEED
Allows the VM system to decrease the in-memory priority
of pages in the specified range.  Additionally future references to
this address range will incur a page fault.
.Dv MADV_FREE
gives the VM system the freedom to free pages,
and tells the system that information in the specified page range
is no longer important.  This is an efficient way of allowing 
.Xr malloc 3
to free pages anywhere in the address space, while keeping the address space
valid.  The next time that the page is referenced, the page might be demand
zeroed, or might contain the data that was there before the 
.Dv MADV_FREE
call.
References made to that address space range will not make the VM system
page the information back in from backing store until the page is
modified again.
.El
.Sh RETURN VALUES
Upon successful completion,
.Fn madvise
returns 0.  Otherwise a value of -1 is returned and
.Va errno
is set to indicate the error.
.Sh ERRORS
The
.Fn madvise
function will fail if:
.Bl -tag -width Er
.It Bq Er EINVAL
The virtual address range specified by the
.Fa addr
and 
.Fa len
arguments is not valid.
.El
.Sh SEE ALSO
.Xr mincore 2 ,
.Xr mprotect 2 ,
.Xr msync 2 ,
.Xr munmap 2 .
.Sh HISTORY
The
.Fn madvise
function first appeared in
.Bx 4.4 .
